// Templatic class A is ok.
// (Implicit type parameter T and name not ending in "const").
template <typename T>
class A {
  A();
};

template <typename T>
A<T>::A() {}

// Class B_const is ok.
// (Explicit type parameter T and name ending in "const").
template <typename T>
class B_const<T> {
  B_const();
};

template <typename T>
B_const<T>::B_const() {}

// Class C_const is **NOT** ok.
// (Implicit type parameter T and name ending in "const").
template <typename T>
class C_const {
  C_const();
};

template <typename T>
C_const<T>::C_const() {}
